;;;; -*- mode:Scheme -*- ;;;;
;;
;; loader.scm
;; 
;; This is the file you actually want to execute.
;; It loads all five code files, then the knowledge file, 
;; then executes a best-first search for the desired solution.
;;

;; Load the files (compiled or otherwise):
(cd "/mit/6.034/Project/SUNbin")
(load "search")
(load "rule-utils")
(load "forward")
(load "match")
(load "schedule")

(cd "/mit/catfoo/6.034")
(define (extend-path path)
;  (display* "Extending the path " (path-reverse path))
  (remove-falses
   (map
    (lambda (next-node)
      (if (member next-node (path-nodes path))
	  #f
	  (make-path
	   #f				; path value is not relevant here
	   (cons next-node (path-nodes path)))))
    (get-neighboring-nodes (path-head-node path)))))

;; Extend a path to the neighbors of the head node
;; Returns a list of extended paths (with values given by the heuristic function)


(define (extend-path-with-heuristic path heuristic)
;  (display* "Extending the path " (path-reverse path))
  (display* (last (path-head-node path)))
  (remove-falses
   (map
    (lambda (next-node)
      (if (member next-node (path-nodes path))
	  #f
	  (make-path
	   (heuristic next-node)	; path value is from calling heuristic
	   (cons next-node (path-nodes path)))))
    (get-neighboring-nodes (path-head-node path)))))

(define (last node)
	(if (null? (cdr node))
		node
		(last (cdr node))))


;(define (modified-hill-climb)

(define (get-heuristic-value node finish)
  (define (loop assertions score)
    (cond ((null? assertions) score)
	  ((member (car assertions) node)
	   (loop (cdr assertions) (- score 1)))
	  (else
	   (loop (cdr assertions) score))))
  (fluid-let ((*assertions* (copy-list node)))  
    (- (loop finish 0)
(* 0 (length (build-rule-instances '(r8 if ((? ta) is assigned to (? course))
                                           ((? ta) prefers (? course))
                     add ((? ta) has preference for (? course) satisfied))))))))
;(loop finish 0))



(read-k-file "rules.txt")

;(display-assertions)

(best-first *assertions* '(
(6AAA has TA) 
;(6BBB has TA) 
;(6CCC has TA) (6DDD has TA)
;                           (6LLL has TA) (6MMM has TA) 
(6NNN has TA) (6034 has TA)
;                           (6EEE has TA) (6III has TA)
))
(get-step-count)
