// uses class Point

class Line
{
  Point pt1, pt2;

  Line(Point point1, Point point2)
  {
    pt1 = point1;
    pt2 = point2;
  }

  double length()
  {
    double xdiff = (pt1.x - pt2.x);
    double ydiff = (pt1.y - pt2.y);
    return Math.sqrt(xdiff * xdiff + ydiff * ydiff);
  }


  // this prints out the Line as a string.
  void display()
  {
    System.out.println("This is the line between ("
		       + pt1.x + "," + pt1.y
		       + ") and (" + pt2.x + "," + pt2.y
		       + ").");
  }

  // straight from the resource..
  
  Point intersects(Line otherline)
  {
    double x1 = pt1.x;
    double x2 = pt2.x;
    double x3 = otherline.pt1.x;
    double x4 = otherline.pt2.x;

    double y1 = pt1.y;
    double y2 = pt2.y;
    double y3 = otherline.pt1.y;
    double y4 = otherline.pt2.y;

    double ua = ((x4-x3)*(y1-y3) - (y4-y3)*(x1-x3)) /
      ((y4-y3)*(x2-x1) - (x4 - x3)*(y2 - y1));

    double newx = x1 + ua * (x2 - x1);
    double newy = y1 + ua * (y2 - y1);
    return new Point(newx,newy);
  }
}
