// 

// There were 2 errors:
//  1) addEdge(ex4.GraphTest)
//  java.lang.RuntimeException: edge dest error!
//    at ex4.Graph.repCheck(Graph.java:43)
//    at ex4.Graph.addEdge(Graph.java:127)
//    at ex4.GraphTest.addEdge(GraphTest.java:38)
//    2) removeNodesTest(ex4.GraphTest)
//    java.lang.NullPointerException
//      at ex4.GraphTest.removeNodesTest(GraphTest.java:66)
//  There was 1 failure:
//      1) removeEdgesTest(ex4.GraphTest)
//      junit.framework.AssertionFailedError
//        at junit.framework.Assert.fail(Assert.java:32)
//        at junit.framework.Assert.assert(Assert.java:19)
//        at junit.framework.Assert.assert(Assert.java:26)
//        at ex4.GraphTest.removeEdgesTest(GraphTest.java:99)


package ex4;

import java.util.*;
import junit.framework.*;

public class GraphTest extends TestCase {

  Graph graph1;
  Set NodeSet;
  EdgeSet edges;
  
  public GraphTest( String name) { super(name); }
  
  public void makeGraph() {
    graph1 = new Graph();
    assert( graph1.nodeSize() == 0);
    assert(graph1.edgeSize() == 0);
  }

  public void addNode() {
    graph1 = new Graph();
    assert(graph1.addNode("Node1"));
    assert(graph1.nodeSize() == 1);
    assert(graph1.edgeSize() == 0);
  }

  public void addEdge() {
    graph1 = new Graph();
    assert(graph1.addNode("Node1"));
    assert(graph1.addEdge(new Edge("Node1", "Node2", "edge1")) == false);
    assert(graph1.addNode("Node2"));
    assert(graph1.addEdge(new Edge("Node1", "Node2", "edge1")));
    assert(graph1.nodeSize() == 2);
    assert(graph1.edgeSize() == 1);
  }

  public void getNodesTest() {
    graph1 = new Graph();
    graph1.addNode("Node1");
    graph1.addNode("Node2");

    NodeSet = (Set) graph1.getNodes();
    Iterator nit = NodeSet.iterator();

    // i then realized that iterators don't guarantee order, but it seems to
    // be coming out in this order.
    assert((String) nit.next() == "Node2");
    assert((String) nit.next() == "Node1");
  }


  // this tests remove nodes and nodeSize()
  public void removeNodesTest() {
    graph1 = new Graph();

    assert(graph1.nodeSize() == 0);
    graph1.addNode("Node1");
    graph1.addNode("Node2");

    Iterator nit = NodeSet.iterator();

    assert(graph1.nodeSize() == 2);

    graph1.removeNode("Node2");
    assert(graph1.nodeSize() == 1);
    
  }

  // this tests add/remove edges and nodeSize()
  // also tests removeNode to see if it removes edges correctly
  public void removeEdgesTest() {
    graph1 = new Graph();
    
    assert(graph1.edgeSize() == 0);
    graph1.addNode("Node1");
    graph1.addNode("Node2");
    graph1.addNode("Node3");

    assert(graph1.edgeSize() == 0);
    
    graph1.addEdge("From 1 to 2", "Node1", "Node2");
    assert(graph1.edgeSize() == 1);
    
    graph1.addEdge("From 2 to 3", "Node2", "Node3");
    assert(graph1.edgeSize() == 2);

    graph1.addEdge("From 3 to 3", "Node3", "Node3");
    assert(graph1.edgeSize() == 3);

    System.out.println(graph1.toString());
    
    graph1.removeEdge("From 2 to 3", "Node2", "Node3");
    assert(graph1.edgeSize() == 2);

    graph1.addEdge("From 2 to 3", "Node2", "Node3");
    assert(graph1.edgeSize() == 3);

    graph1.removeNode("Node2");
    assert(graph1.nodeSize() == 2);
    assert(graph1.edgeSize() == 1);
  }

  // Tell JUnit what order to run the tests in
  public static Test suite()
  { 
    TestSuite suite = new TestSuite(); 
    suite.addTest(new GraphTest("makeGraph"));
    suite.addTest(new GraphTest("addNode"));
    suite.addTest(new GraphTest("addEdge"));
    suite.addTest(new GraphTest("getNodesTest"));
    suite.addTest(new GraphTest("removeNodesTest"));
    suite.addTest(new GraphTest("removeEdgesTest"));
    return suite;
  }

}
