package ex5.backend;

import java.util.*;


public interface PortfolioActionHandler {

  //private Vector portfolios;

  // @effects constructs new PortfolioActionHandler
  //  public PortfolioActionHandler();

  // @return current price of ticker
  public float getTickerPrice(String ticker);

  // @return true if adding stock is successful
  // @effects adds a stock to the given portfolio
  // @requres portfolioname to be an existing portfolio
  // @modifies portfolio with the name portfolioname
  public boolean addStock(String ticker, int shares, float price, String
			  portfolioname);

  // @effects deletes stock with ticker from portfolio with name.
  // ??? need a way to differentiate different holdings of stocks.
  public boolean delStock(String ticker, String name);

  // @effects creates a new portfolio (empty) with name 'name'
  // @returns PortfolioView of the new empty portfolio
  public PortfolioView createPortfolio(String name);

  // need a portfolio interface! not a public method!
  // @return a portfolio with name 'name'
  //  Portfolio getPortfolio(String name);

  // @return true if successful, false otherwise
  // @effects closes portfolio with name 'name' so no changes can be made
  public boolean closePortfolio(String name);

  // @return true if successful, false otherwise
  // @effects opens existing portfolio with name 'name' so changes can be made
  public boolean openPortfolio(String name);
  
}
