package ex6.backend;

import java.util.*;
import ex6.QuoteServer;
import ex6.NoSuchTickerException;
import ex6.WebsiteDataException;


public class MyPortfolioActionHandler implements PortfolioActionHandler {

 private Vector portfolios;

 public MyPortfolioActionHandler() {
 
  portfolios = new Vector();
  
 }


  // this is caught by the GUI which then pops open a window that
  // explains the error.
  public float getTickerPrice(String ticker) throws NoSuchTickerException,
                                            WebsiteDataException {
    try {
      String pricestring = QuoteServer.getLastValue(ticker);
      float tickerprice = (Float.valueOf(pricestring)).floatValue();
      return tickerprice;
    } catch (NoSuchTickerException e) {
      throw e;
    } catch (WebsiteDataException e) {
      throw e;
    }
  }

 

 public boolean addStock(String ticker, int shares, float price, String
name) {
  int index = getPortfolioIndex(name);
  Vector pf = (Vector) portfolios.elementAt(index);
  Stock newstock = new MyStock(ticker, shares, price);
  pf.add(newstock);
  return true;
 }

 private int getStockIndex(int pfindex, String ticker) {
   Vector stocks = (Vector) portfolios.elementAt(pfindex);
   Iterator it = stocks.iterator();
   it.next(); //gets past name
   int counter = 1;
   Stock astock;
   
   for(;it.hasNext(); ) {
     astock = (Stock)it.next();
     if ((astock.getTicker()).equals(ticker))
       return counter;
     counter++;
   }
   return -1;
  
 }

 public boolean delStock(String ticker, String name) {
  int index = getPortfolioIndex(name);
  Vector pf = (Vector) portfolios.elementAt(index);
  
  int stockindex = getStockIndex(index, ticker);
  pf.remove(stockindex);
  return true;
 }

 public PortfolioView createPortfolio(String name) {

  Vector newfolio = new Vector();
  newfolio.add(name);

  portfolios.add(newfolio);

  return new MyPortfolioView(newfolio);
 }

 private int getPortfolioIndex(String name) {
  Vector pf;
  int counter = 0;
  for(Iterator it = portfolios.iterator(); it.hasNext(); counter++) {
    pf = (Vector)it.next();
    //    if(pf != null) 
    if ((pf.elementAt(0)).equals(name))
      return counter;
  }
  return -1;
 }
   
 Vector getPortfolio(String name) {
  int index = getPortfolioIndex(name);

  if (index > -1)
   return (Vector) portfolios.elementAt(index);
  else return null;
 }

  // public boolean closePortfolio(String name) {
  // pretned to close hte portfolio
  // System.out.println("portfolio closed!");
  //return true;
  //}

  // i decided not to implement close and open portfolio
  // because i didn't end up implementing files and stuff..
  public boolean deletePortfolio(String name) {
    int index = getPortfolioIndex(name);
    if (index > -1) {
    portfolios.remove(index);
    return true;
    }
    return false;
    
  }
  
  
}



