package ex6.backend;

import java.util.*;
import ex6.NoSuchTickerException;
import ex6.WebsiteDataException;

public interface PortfolioActionHandler {

  //private Vector portfolios;

  // @effects constructs new PortfolioActionHandler
  //  public PortfolioActionHandler();

  // @return current price of ticker
  public float getTickerPrice(String ticker) throws NoSuchTickerException,
  WebsiteDataException;
  
  // @return true if adding stock is successful
  // @effects adds a stock to the given portfolio
  // @requres portfolioname to be an existing portfolio
  // @modifies portfolio with the name portfolioname
  public boolean addStock(String ticker, int shares, float price, String
			  portfolioname);

  // @effects deletes stock with ticker from portfolio with name.
  // ??? need a way to differentiate different holdings of stocks.
  public boolean delStock(String ticker, String name);

  // @effects creates a new portfolio (empty) with name 'name'
  // @returns PortfolioView of the new empty portfolio
  public PortfolioView createPortfolio(String name);

  // @effects deletes the portfolio with this name
  // @return a portfolio with name 'name'
  public boolean deletePortfolio(String name);

  // @return true if successful, false otherwise
  // @effects closes portfolio with name 'name' so no changes can be made
  // public boolean closePortfolio(String name);

  // @return true if successful, false otherwise
  // @effects opens existing portfolio with name 'name' so changes can be made
  //  public PortfolioView openPortfolio(String name);
  
}
