import java.awt.Color;

public class Sphere implements Drawable {
       protected static float lx, ly, lz;
        float sphereradius, r2;
        int sphereColor;
        float spherex, spherey;
        
       public static void setLightDir(float x, float y, float z) {
         float t = 1.0f/(float) Math.sqrt(x*x + y*y + z*z);
         lx = x*t;
         ly = y*t;
         lz = z*t;
       }
       
       public Sphere() {
        lx = 0;
        ly = 0;
        lz = 0;
        spherex = 0;
        spherey = 0;
        sphereradius = 0;
        sphereColor = 0;
       }
       
       public Sphere(float x, float y, float radius, int fillColor){
        spherex = x;
        spherey = y;
        sphereradius = radius;
        sphereColor = fillColor;
        lx = 0;
        ly = 0;
        lz = 0;
        r2 = radius*radius;
      
       }        
       
        public void Draw(Raster raster) {
            int height = raster.getHeight();
            int width = raster.getWidth();
            int left = (int) Math.floor(spherex - sphereradius);
            int right = (int) Math.ceil(spherex + sphereradius);
            int top = (int) Math.floor(spherey - sphereradius);
            int bottom = (int) Math.ceil(spherey + sphereradius);
            
            if (left < 0)
                left = 0;
            if (top < 0)
                top = 0;
            if (bottom > height);
                bottom = height;
            if (right > width)
                right = width;
                
            for (int w = left; w<right; w++) {
                for (int h = top; h<bottom; h++) {
                    if ( (r2 - (w-spherex)*(w-spherex) 
                            - (h-spherey)*(h-spherey)) > 0) {
                       raster.setPixel(colormaker(w,h), w, h);
                }
            }
        }
    }   
    
    int colormaker(int x, int y) {
        //float newx = lx * sphereradius;
        //float newy = ly * sphereradius;
        
        
        float ratio = (float) Math.cos(Math.sqrt((x-spherex)*(x-spherex) 
                            + (y-spherey)*(y-spherey))/sphereradius);
        float[] hsb = new float[3];
        int a1   = ((sphereColor>>24)&0x000000FF);
        int r1 = ((sphereColor>>16)&0x000000FF);
        int g1 = ((sphereColor>>8)&0x000000FF);
        int b1 =  (sphereColor&0x000000FF);
        Color.RGBtoHSB(r1, g1, b1, hsb);
        hsb[2] = ratio*hsb[2];
        return Color.HSBtoRGB(hsb[0],hsb[1],hsb[2]);
    }
}

