import java.applet.Applet;
import java.awt.*;
import java.util.Vector;

/** Applet mas110shower
*  
*  @author   Tom White
*  @version  1.0
*/
public class mas110shower
  extends java.applet.Applet
  implements java.lang.Runnable {

        public class panelInfo {
                mas110panel p;
                Image buffer;
                Graphics g;
                String name;
                int posX, posY;
        }

        float speed = 1.0f, globalMx = 0.5f, globalMy = 0.5f;
        int globalW, globalH, w, h;
        Vector panels;
        boolean panelsFound=false, resetEpoch=false;
        
        public static final String name    = "mas110shower";
        public static final String version = "1.0";
        
        Thread  runner;
        
        public panelInfo doLoad(String className) {
                Class cl;
                Object o;
                panelInfo pInfo;
                int i=0;

                try {
                        cl = Class.forName(className);
                        o = cl.newInstance();
                        if(o instanceof mas110panel) {
                                /* make and fill out new panelInfo */
                                pInfo = new panelInfo();
                                pInfo.p = (mas110panel)o;
                                pInfo.p.w = globalW;
                                pInfo.p.h = globalH;
                                pInfo.buffer = createImage(globalW, globalH);
                                pInfo.g = pInfo.buffer.getGraphics();
                                pInfo.name = className;

                                /* Save panel and name */
                                if(!panelsFound) {
                                        panelsFound = true;
                                        panels = new Vector();
                                }                               
                                panels.addElement(pInfo);
                                return pInfo;
                        }
                }
                catch(Exception e) {
                        System.out.println("problem loading " + className + ": " + e);
                }
                return null;
        }

        public boolean mouseMove(Event e, int x, int y) {
                if(x > 10 && x < globalW+10 && y > 10 && y < globalH+10) {
                   globalMx = ((float)x - 10.0f)/(float)globalW;
                   globalMy = ((float)y - 10.0f)/(float)globalH;
                }                  
                return false;
        }

        void getApps() {
                int i=1;
                boolean stop=false;
                String file;
                panelInfo pi;
                int curX, curY;
                
                curX = 10;
                curY = globalW + 20;
                while(!stop) {
                        file = getParameter("panel" + i);
                        if(file != null && file.length() > 0) {
                                pi = doLoad(file);
                                if(pi != null) {
                                        pi.posX = curX;
                                        pi.posY = curY;
                                        curX += globalW+10;
                                        if(curX+globalW > w) {
                                                curX = 10;
                                                curY += globalH+10;
                                        }
                                }
                                ++i;
                        }
                        else stop=true;
                }
        }                       

        /** Performs applet initialization 
        */
        public void init()
        {
                Dimension d = size();
                w = d.width;
                h = d.height;
                
                globalW = 100;
                globalH = 100;

		Scrollbar mxBar = new Scrollbar(Scrollbar.HORIZONTAL, 0, 330, 0, 100);
		Scrollbar myBar = new Scrollbar(Scrollbar.VERTICAL, 330, 0, 0, 100);
		p.add(mxBar);
		p.add(myBar);

                getApps();
                resetEpoch=true;



        }
                
        /** Draws the applet.
        */
        public void paint(Graphics g)
        {
                g.setColor(Color.black);


                g.drawRect(10, 10, globalW, globalH);
                panelInfo pi;



	g.fillRect(0,0,100,100);
	g.fillRect(110,0,100,100);
	g.fillRect(220,0,100,100);
	g.fillRect(0,110,100,100);
	g.fillRect(110,110,100,100);
	g.fillRect(220,110,100,100);
	g.fillRect(0,220,100,100);
	g.fillRect(110,220,100,100);
	g.fillRect(220,220,100,100);

	

	
                Toolkit.getDefaultToolkit().sync(); 
	}
        
        public void update(Graphics g) {
                paint(g);
        }

        /** The main entry point for the applet.
        */
        public void start()
        {
                // Either start the applet here or create 
                // a thread to run the applet in.               
                if (runner == null)
                {
                        runner = new Thread(this);
                        runner.start();
                }
        }
        
        /** Called when you create a new thread with this class.
        */
        public void run()
        {
                long then, now, napTime, epoch;
                panelInfo pi;
                
                epoch = System.currentTimeMillis();
                while (runner == Thread.currentThread()) 
                {
                        then = System.currentTimeMillis();
                        if(resetEpoch) {
                                epoch = then;
                                resetEpoch = false;
                        }                       

                        for(int i=0;i<panels.size();i++) {
                                pi = (panelInfo)panels.elementAt(i);
                                pi.p.mx = globalMx;
                                pi.p.my = globalMy;
                                pi.p.draw(pi.g, (float)(speed*(then-epoch))/1000.0f);
                                globalMy = pi.p.my;
                        }
                        paint(this.getGraphics());
                        
                        try { Thread.sleep(5); }
                        catch (InterruptedException e) { }
                        now = System.currentTimeMillis();
                        /* sleep for at least 20 */
                        napTime = 20 - (now - then);
                        if (napTime > 0) {
                        //System.out.println("Sleeping " + napTime);
                                try { Thread.sleep(napTime); }
                                catch (InterruptedException e) {}
                        }
                }
        }
        
        /** Stops the applet from executing.
        */
        public void stop()
        {
                // Stop the applet or the thread it's running in.
                if (runner != null)
                {
                        runner.stop();
                        runner = null;
                }
        }
        
        /** Free up any applet resources.
        */
        public void destroy()
        {
                // Dispose of images, net connections, windows, etc.
        }
        
        /** Returns a text description of the applet.
        */
        public String getAppletInfo()
        {
                // Return a String containing author, version, copyright, 
                // and other information.
                return name + " version " + version;
        }
        
        /** Clean up done here.
        *  This method is called when the object is collected.
        *  @throws Throwable
        */
        protected void finalize()
        {
                // Put any code here you want to execute when the 
                // object is collected, such as closing sockets 
                // or files.
        }       
}
