//*******************************************************
// snps.c
//
// all sorts of SNP functions, and reading SNPs (and blocks) from files.
// self explantory.
//
#include <stdio.h>
#include "defs.h"
#include "snps.h"


int snpKnown(int position) {
  int i = 0;

  if (! Known) return 1;
  
  while (getKnownPosition(i) < position)
    i++;

  if (getKnownPosition(i) == position)
    return 1;
  else {
    // printf("grep %d flat.0.filt.out\n", position);
    return 0;
  }  
}

int getindexfrompos(int pos) {
  int i = 0;

  while (getSNPpos(i) < pos)
    i++;

  if (getSNPpos(i) == pos)
    return i;
  else return -1;
}


int getKnownPosition(int i) {
  return knownSNParray[i];
}

int getSNPpos(int num) {
  //if (num < totalSNPs)
    return snparray[num];
    //else
    //return -1;
}


// reads a file in EB format
// using the SNPs as the array of 'known' snps
int readKnownSNPfromfile(char* filename) {
  int i = 0;
  FILE* fileptr;
  int snp;
  char* alleles;

  fileptr = fopen(filename, "r");
  alleles = (char *)malloc((1 + NUMCHROMS) * sizeof(char));
  while (fscanf(fileptr, "%d %*s %*s %s", &snp, alleles) == 2) {
    knownSNParray[i] = snp;
    knownallelearray[i]=alleles;
    i++;
    alleles = (char *)malloc((1 + NUMCHROMS) * sizeof(char));
  }
  free(alleles);

  fclose(fileptr);

  return i;
}

// returns the number of blocks read into the array
// file format:
// SNP1 index SNP2 index
int readblocksfromfile(char *filename) {
  int i = 0;
  FILE* fileptr;
  int snp1, snp2;

  fileptr = fopen(filename, "r");

  fscanf(fileptr, "%*s %*s %*s %*s");

  while (fscanf(fileptr, "%d %*s %d %*s", &snp1, &snp2) == 2) {
    blockarray[i][0] = snp1;
    blockarray[i][1] = snp2;
    i++;
  }

  fclose(fileptr);

  return i;

}

// returns the number of SNPs read into the array.
// one snp per line.
int readSNPfromfile(char* filename) {
  int i = 0;
  FILE* fileptr;
  int snp;
  char* alleles;

  fileptr = fopen(filename, "r");
    alleles = (char *)malloc((1 + NUMCHROMS) * sizeof(char));
  while (fscanf(fileptr, "%d %*s %*s %s", &snp, alleles) == 2) {
    snparray[i] = snp;
    allelearray[i]=alleles;
    i++;
    alleles = (char *)malloc((1 + NUMCHROMS) * sizeof(char));
  }
  free(alleles);

  fclose(fileptr);

  return i;
}


